library ieee;
use ieee.std_logic_1164.all;

entity cu is
  port (nw, clk, mu, mm: in std_logic;
        sela,selb,rega,regb,regm,fine: out std_logic);
end cu;

architecture beh of cu is
signal stato: integer range 0 to 5:= 0;
signal tfine: std_logic;

begin

process(clk)
 begin 
   if clk'event and clk='0' then
     if nw='1' then stato <= 1; -- idle to inizializza
     else case stato is
           when 1 => stato <= 2; -- inizializza to confronto
           when 2 => if mu='1'  then stato <= 5; -- confronto to fine
                     elsif mm='1' then stato <= 3; -- confronto to aggiorna ma  
                     else  stato <= 4; -- confronto to aggiorna mb
                   end if;
           when 3 | 4 =>  stato <= 2; -- aggiorna to confronto
           when 5 =>  stato <= 0; -- fine to idle
           when others => NULL;
        end case;
     end if;
     fine <= tfine;
   end if;  
   
 end process;
 
 process(stato)
  begin  
   case stato is
   when 0 =>  sela<= '0';
              selb<=  '0';
              rega<= '0';
              regb<= '0';
              regm<= '0';
              tfine<= '0';
   when 1  => sela<= '0'; -- inizializza
              selb<= '0';
              rega<= '1';
              regb<= '1';
              regm<= '0';
              tfine<= '0';
   when 2  => sela<= '0'; -- confronto
              selb<= '0';
              rega<= '0';
              regb<= '0';
              regm<= '0';
              tfine<= '0';
   when 3  => sela<= '1'; -- aggiorna ma
              selb<= '1';
              rega<= '1';
              regb<= '0';
              regm<= '0';
              tfine<= '0'; 
   when 4  => sela<= '1'; -- aggiorna mb
              selb<= '1';
              rega<= '0';
              regb<= '1';
              regm<= '0';
              tfine<= '0';
   when 5  => sela<= '1'; -- fine
              selb<= '1';
              rega<= '0';
              regb<= '0';
              regm<= '1';
              tfine<= '1';                                             
  end case;
end process;         
               
 
 end beh;
   