library ieee;
use ieee.std_logic_1164.all;

entity regfile is
  port( rst,clk: in std_logic;
        ra,rb,rd: in integer range 0 to 31;
        regwrite: in std_logic;
        dS: in std_logic_vector(31 downto 0);
        dA,dB: out std_logic_vector(31 downto 0) );
end regfile;

architecture beh of regfile is
  type  Treg is array( 0 to 31) of std_logic_vector(31 downto 0);
  signal reg: Treg;
  begin
    
    dA <= reg(ra);
    dB <= reg(rb);
    
    process(rst,clk)
      begin
        if rst='1' then
          for i in 0 to 31 loop
            reg(i) <= (reg(i)'range => '0');
          end loop  
        elsif clk'event and clk='1' and regwrite = '1' then
             reg(rd)<= dS;
        end if;
      end process;
    end beh;
    